////////////////////////////////////////////////////////////////////////
// ela-wise methods

var eval_elav_power = function (can_ori_ctx, can_res_ctx, can_width, can_height) {
  debug_output("eval_elav_power");

  var ori_data = can_ori_ctx.getImageData(0, 0, can_width, can_height);
  var ori_arr = ori_data.data;
  var arr_len = ori_arr.length;

  var res_data = can_res_ctx.getImageData(0, 0, can_width, can_height);
  var res_arr = res_data.data;

  if (arr_len != res_arr.length) {
    return;
  }
  if (arr_len==0) {
    return false;
  }
    
  let idx = arr_len - 1;
  while (idx >= 0) {
    idx -= 1;
    res_arr[idx] = res_arr[idx]**2;
    idx -= 1;
    res_arr[idx] = res_arr[idx]**2;
    idx -= 1;
    res_arr[idx] = res_arr[idx]**2;
    idx -= 1;
  }
  can_res_ctx.putImageData(res_data, 0, 0);
};

var eval_elav = function (can_ori_el, can_ori_ctx, can_res_el, can_res_ctx, can_width, can_height, blur, boost_ela, finalize_work) {
  debug_output("eval_elav");

  var img_resaved = new Image;
  img_resaved.onload = function () {

    can_res_ctx.globalCompositeOperation = "copy";
    can_res_ctx.drawImage(img_resaved, 0, 0);
    can_res_ctx.globalCompositeOperation = "difference";
    can_res_ctx.drawImage(can_ori_el, 0, 0);
    if (boost_ela) {
      eval_elav_power(can_ori_ctx, can_res_ctx, can_width, can_height);
    }

    if (finalize_work) {
      finalize_work();
    }
  }
  img_resaved.src = can_ori_el.toDataURL("image/jpeg", (1-blur));
};

