////////////////////////////////////////////////////////////////////////
// development-related

var under_debug = false;

////////////////////////////////////////////////////////////////////////
// images/canvases

var img_size_width_el = null;
var img_size_height_el = null;

var can_ori_cvr_el = null;
var can_res_cvr_el = null;
var can_thm_cvr_el = null;

var can_ori_el = null;
var can_res_levels_el = null;
var can_res_slopes_el = null;
var can_res_ela_el = null;
var can_res_pca_el = null;
var can_aux_el = null;

var can_ori_scl_el = null;
var can_res_scl_el = null;

var can_ori_ctx = null;
var can_res_levels_ctx = null;
var can_res_slopes_ctx = null;
var can_res_ela_ctx = null;
var can_res_pca_ctx = null;
var can_aux_ctx = null;

var can_ori_scl_ctx = null;
var can_res_scl_ctx = null;

var can_width = 0;
var can_height = 0;

var img_request = null;
var img_request_runs = false;

var img_result_form = "fin";
var image_stage_shown = img_result_form;
var img_scaled = false;
var img_aspect = 1;

////////////////////////////////////////////////////////////////////////
// notices, mainly on image loading issues

var file_notice_hld_el = "";
var file_notice_el = "";

var default_notice_timeout = 5000;
var to_hide_notice = null;

////////////////////////////////////////////////////////////////////////
// image loading

var image_is_loaded = false;
var image_has_exif = false;
var image_has_thumb = false;

var last_loaded_path = "";
var last_loading_path = "";
var last_loaded_local = false;
var last_loading_local = false;
var image_file_start = "";
var image_file_start_loading = "";
var image_file_comment = "";
var image_file_comment_loading = "";

var png_xmp = {};
var png_xmp_loading = {};

////////////////////////////////////////////////////////////////////////
// UI-related

var main_part = "about";
var disp_part_meta = "file";
var disp_part_about = "forensics";

var class_top_bt_disabled = "bt-main-disabled";
var class_el_hidden = "not-shown";
var class_header_gps = "image-header-gps";
var class_header_highlight = "image-header-highlight";
var class_header_highlight_other = "image-header-highlight-other"
var class_header_key = "image-header-key";
var meta_section_not = "meta-sect-missing";
var class_thumb_wo_items = "image-thumb-without-items";
var class_show_more = "bt-show-more";
var class_show_less = "bt-show-less";
var class_part_more = "part-shown-more";
var class_part_less = "part-shown-less";

var bt_meta_exif = null;
var bt_meta_thumb = null;
var bt_meta_file = null;

////////////////////////////////////////////////////////////////////////
// controls on methods

var center_levels_val = 0.5;
var contrast_levels_val = 10;
var gray_levels_val = false;
var spread_levels_val = true;

var form_slopes = "any";
var lumin_slopes = false;
var step_slopes = 1;
var light_slopes = 20;
var slopes_light_el = null;

var blur_ela = 0.25;
var light_ela = 20;
var boost_ela = false;
var ela_blur_el = null;
var ela_light_el = null;
var ela_inner_working = false;

var pca_eigen_rank = 1;
var pca_eigen_mode = 0;
var light_pca = 10;
var light_pca_display = "2.0";
var light_pca_use = "2.0";
var pca_light_el = null;

////////////////////////////////////////////////////////////////////////
// runtime states for UI actions

var last_scale_form = "";

var last_spread_levels_val = "";

var last_slopes_step = "";
var last_slopes_lumin = "";
var last_slopes_form = "";

var last_blur_ela = -1;
var last_boost_ela = "";

var make_ela_delay = 50;
var make_ela_delay_set = 0;
var make_ela_setup = null;
var make_ela_last_set = 0.25;
var make_ela_last_used = -1;

var pca_mean_values = null;
var pca_eigen_vectors = null;
var pca_eigen_rank_last = -1;
var pca_eigen_mode_last = "";
var pca_tried_onset = false;
var pca_failed = false;

var last_scale_awaits = false;
var last_scale_update = 0;

